package com.framsticks.communication;

import com.framsticks.util.FramsticksException;
import com.framsticks.util.dispatching.ExceptionResultHandler;
import com.framsticks.util.dispatching.FutureHandler;

public abstract class ClientSideResponseFuture extends FutureHandler<Response> {

	public ClientSideResponseFuture(ExceptionResultHandler handler) {
		super(handler);
	}

	protected abstract void processOk(Response response);

	@Override
	protected final void result(Response response) {
		if (response.getOk()) {
			processOk(response);
		} else {
			handle(new FramsticksException().msg("invalid response").arg("comment", response.getComment()));
		}
	}

}
