package com.framsticks.communication.util;

import com.framsticks.communication.ClientSideResponseFuture;
import com.framsticks.communication.Response;

import org.apache.log4j.Logger;

/**
 * @author Piotr Sniegowski
 */
public class LoggingStateCallback extends ClientSideResponseFuture {

	protected final Logger logger;
	protected final String message;

	public LoggingStateCallback(Logger logger, String message) {
		super(null);
		this.logger = logger;
		this.message = message;
	}

	// @Override
	// public void handle(FramsticksException e) {
	// 	logger.error("failed to " + message + " with " + e);
	// }

	@Override
	protected void processOk(Response response) {
		logger.debug(message);
	}

}
