package com.framsticks.communication.util;

import com.framsticks.communication.EventCallback;
import com.framsticks.communication.Subscription;
import com.framsticks.communication.SubscriptionCallback;
import org.apache.log4j.Logger;

/**
 * @author Piotr Sniegowski
 */
public class LoggingSubscriptionCallback<C> extends SubscriptionCallback<C> {

	protected final Logger logger;
	protected final String message;
	private final EventCallback eventCallback;

	public LoggingSubscriptionCallback(Logger logger, String message, EventCallback eventCallback) {
		this.logger = logger;
		this.message = message;
		this.eventCallback = eventCallback;
	}

	@Override
	public EventCallback subscribed(Subscription<? super C> subscription) {
		if (subscription == null) {
			logger.error("failed to subscribe for " + message);
			return null;
		}
		logger.info("successfuly subscribed for " + message);
		return eventCallback;
	}
}
