package com.framsticks.gui;

import com.framsticks.util.dispatching.Dispatcher;
import com.framsticks.util.dispatching.Task;
import com.framsticks.util.dispatching.ThrowExceptionHandler;

import javax.swing.*;
import com.framsticks.util.dispatching.RunAt;

/**
 * @author Piotr Sniegowski
 */
public class SwingDispatcher<C> implements Dispatcher<C> {

	@SuppressWarnings("rawtypes")
	protected static final SwingDispatcher instance = new SwingDispatcher();

	@SuppressWarnings("unchecked")
	public static <C> Dispatcher<C> getInstance() {
		return (Dispatcher<C>) instance;
	}

	public SwingDispatcher() {
		dispatch(new RunAt<C>(ThrowExceptionHandler.getInstance()) {
			@Override
			protected void runAt() {
				Thread.currentThread().setName("gui");
			}
		});
	}

	@Override
	public final boolean isActive() {
		return SwingUtilities.isEventDispatchThread();
	}

	@Override
	public final void dispatch(RunAt<? extends C> runnable) {
		assert !(runnable instanceof Task);
		SwingUtilities.invokeLater(runnable);
	}

}
