package com.framsticks.gui.console;

import com.framsticks.communication.Connection;
import com.framsticks.communication.ConnectionListener;
import com.framsticks.params.annotations.AutoAppendAnnotation;
import com.framsticks.params.annotations.FramsClassAnnotation;

@FramsClassAnnotation
public class TrackConsole extends Console implements ConnectionListener {

	public TrackConsole() {
	}

	@AutoAppendAnnotation
	public TrackConsole setConnection(Connection connection) {
		this.connection = connection;
		return this;
	}

	@Override
	protected void joinableStart() {
		super.joinableStart();
		connection.getListeners().add(this);
	}

	@Override
	protected void joinableInterrupt() {
		connection.getListeners().remove(this);
		super.joinableInterrupt();
	}


	@Override
	public void connectionOutgoing(String line) {
		dispatchWrite(line);
	}

	@Override
	public void connectionIncomming(String line) {
		dispatchWrite(line);
	}

}
