package com.framsticks.gui.controls;

import com.framsticks.params.PrimitiveParam;

import javax.swing.*;
import java.awt.*;

@SuppressWarnings("serial")
public class TextAreaControl extends TextControl {

	protected final JTextArea textArea;
	protected final JScrollPane textScrollPane;

	public TextAreaControl(PrimitiveParam<?> valueParam) {
		super(valueParam);
		textArea = new JTextArea();
		textArea.setName("value");
		textArea.setLineWrap(true);
		textArea.setWrapStyleWord(true);
		textArea.setEditable(!isReadOnly());
		addDefaultDocumentListener(textArea);

		textScrollPane = new JScrollPane(textArea);
		this.setLayout(new BorderLayout());
		this.add(textScrollPane, BorderLayout.CENTER);
		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));
		textArea.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));

		this.revalidate();
	}

	@Override
	public Dimension getPreferredSize() {
		Dimension result = super.getPreferredSize();
		return new Dimension(result.width, Math.min(result.height, this.getMaximumSize().height));
	}

	@Override
	public void pushValueToUserInterfaceImpl(Object value) {
		textArea.setText((String) value);
		this.revalidate();
	}

	@Override
	public Object pullValueFromUserInterface() {
		return textArea.getText();
	}

}
