package com.framsticks.util;

import com.framsticks.util.dispatching.Dispatcher;
import com.framsticks.util.dispatching.ExceptionResultHandler;
import com.framsticks.util.dispatching.Task;
import com.framsticks.util.dispatching.RunAt;

/**
 * @author Piotr Sniegowski
 */
public abstract class PeriodicTask<C> extends RunAt<C> {

	protected final long period;
	protected Dispatcher<? super C> dispatcher;

	public PeriodicTask(ExceptionResultHandler handler, Dispatcher<? super C> dispatcher, long period) {
		super(handler);
		this.period = period;
		this.dispatcher = dispatcher;
		dispatcher.dispatch(this);
	}


	public void again() {
		dispatcher.dispatch(new Task<C>(handler, period) {
			@Override
			protected void runAt() {
				PeriodicTask.this.runAt();
			}
		});
	}

}
