package com.framsticks.util.dispatching;

/**
 * @author Piotr Sniegowski
 */
public class AtOnceDispatcher<C> implements Dispatcher<C> {

	@SuppressWarnings("rawtypes")
	protected static final AtOnceDispatcher instance = new AtOnceDispatcher();

	@SuppressWarnings("unchecked")
	public static <C> Dispatcher<C> getInstance() {
		return (Dispatcher<C>) instance;
	}

	@Override
	public final boolean isActive() {
		return true;
	}

	@Override
	public final void dispatch(RunAt<? extends C> runnable) {
		runnable.runAt();
	}


}
