package com.framsticks.util.dispatching;

import com.framsticks.util.FramsticksException;

/**
 * @author Piotr Sniegowski
 */
public abstract class Future<T> implements ExceptionResultHandler {

	protected abstract void result(T result);

	public final void pass(T result) {
		try {
			result(result);
		} catch (FramsticksException e) {
			handle(e);
		}
	}


}
