package com.framsticks.util.dispatching;

import com.framsticks.util.FramsticksException;

public abstract class RunAt<C> implements ExceptionResultHandler, Runnable {

	protected final ExceptionResultHandler handler;

	public RunAt(ExceptionResultHandler handler) {
		assert handler != null;
		this.handler = handler;
	}

	protected abstract void runAt();

	public final void run() {
		try {
			runAt();
		} catch (FramsticksException e) {
			handle(e);
		}
	}



	@Override
	public final void handle(FramsticksException exception) {
		handler.handle(exception);
	}

}
