package com.framsticks.util.dispatching;

/**
 * @author Piotr Sniegowski
 */
public abstract class Task<C> extends RunAt<C> {

	protected final long moment;

	public Task(ExceptionResultHandler handler) {
		super(handler);
		moment = System.currentTimeMillis();
	}

	public Task(ExceptionResultHandler handler, long moment) {
		super(handler);
		this.moment = System.currentTimeMillis() + moment;
	}

	public final long getMoment() {
		return moment;
	}

}
